package ParentCategorySelector::CMS;

use strict;
use Data::Dumper;

sub change_jquery {
    my ($cb, $app, $template) = @_;

    my $q = $app->param;
    return if !($q->param('__mode') eq 'view' && $q->param('_type') eq 'entry');

    my $plugin = MT->component("ParentCategorySelector");
    return if !$plugin->get_config_value('use_plugin', 'blog:'.$app->blog->id);

    my $old = <<HTML;
<mt:else>
  <script type="text/javascript" src="<\$mt:var name="static_uri"\$>jquery/jquery.min.js?v=<mt:var name="mt_version_id" escape="URL">"></script>
HTML
    $old = quotemeta($old);

    my $new = <<HTML;
<mt:else>
  <script type="text/javascript" src="<\$mt:var name="static_uri"\$>plugins/ParentCategorySelector/js/jquery-1.7.min.js?v=<mt:var name="mt_version_id" escape="URL">"></script>
HTML
    $$template =~ s/$old/$new/;
}

sub add_script {
    my ($cb, $app, $template) = @_;

    my $q = $app->param;
    return if !($q->param('__mode') eq 'view' && $q->param('_type') eq 'entry');

    my $plugin = MT->component("ParentCategorySelector");
    return if !$plugin->get_config_value('use_plugin', 'blog:'.$app->blog->id);

    my $old = <<HTML;
<mt:include name="include/footer.tmpl" id="footer_include">
HTML
    $old = quotemeta($old);

    my $is_primary  = $plugin->get_config_value('is_primary', 'blog:'.$app->blog->id);


    my $new = <<HTML;
<mt:include name="include/footer.tmpl" id="footer_include">
<style type="text/css">
</style>
<script type="text/javascript">
/* <![CDATA[ */
var is_primary = '$is_primary';
jQuery('#category-selector-list').on('change', '.add-category-checkbox', function(){
    var cats = jQuery('.add-category-checkbox');

    var name = jQuery(this).attr('name');
    var cat_id = name.replace(/add_category_id_(.*)/,'\\\$1');
    var primary_cat_id = cat_id;

    var width = jQuery(this).parent().attr('style');
    var width_size = width.replace(/.*\\s(\\d+)px;/,'\\\$1');

    var prevInput;
    var parent_width;
    var parent_width_size;
    var counter = 0;
    while (true) {
        if (!cats.index(this)) {
            break;
        }
        prevInput = cats.eq(cats.index(this) - (counter + 1));
        parent_width = prevInput.parent().attr('style');
        parent_width_size = parent_width.replace(/.*\\s(\\d+)px;/,'\\\$1');

        if (parent_width_size > width_size) {
            if (jQuery(this).prop('checked')) {
                prevInput.attr('checked', 'checked');
                name = prevInput.attr('name');
                cat_id = name.replace(/add_category_id_(.*)/,'\\\$1');
                prevInput.parent().parent().parent().addClass('selected');
            } else {
                prevInput.removeAttr('checked');
                prevInput.parent().parent().parent().removeClass('selected');
            }
            if (parent_width_size == '165') {
                break;
            }
            width_size = parent_width_size;
        }
        counter++;
    }

    var selected_cat_id;
    var list = new Array(); 
    jQuery('.list-item.selected').each(function(){
        name =jQuery(this).find('input').attr('name');
        selected_cat_id = name.replace(/add_category_id_(.*)/,'\\\$1');
        if (is_primary == 'on') {
            if (selected_cat_id == primary_cat_id) {
                list.unshift(selected_cat_id);
            } else {
                list[list.length] = selected_cat_id;
            }
        } else {
            list[list.length] = selected_cat_id;
        }
    });
    MT.App.selectedCategoryList = Array.fromPseudo( list );
//app.catList.setSelection(MT.App.selectedCategoryList);
    app.catList.redraw();
});
/* ]]> */
</script>
HTML
    $$template =~ s/$old/$new/;
}

1;
